using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Runtime.InteropServices; // needed for DllImport
using System.Text; // needed for StringBuilder Class
using System.IO;

// Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
// or the page: 
// http://www.cognaxon.com/index.php?page=wsqlib_NETnotes
// FAQ (Frequently Asked Questions)
// for .NET developers on using WSQ image library


namespace wsq_demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private WSQImageLibraryNativeMethods32 WSQ_library_native_methods;


        private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.Button buttonRegister;
		private System.Windows.Forms.PictureBox OutputPicture;
		private System.Windows.Forms.Button buttonStreamToWSQ;
		private System.Windows.Forms.Button buttonWSQtoStream;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		static IntPtr bp;
		static System.Drawing.Bitmap b;
		static byte[] input_data_stream;
		static byte[] input_data_stream2;
		static byte[] output_data_stream;
		static byte[] output_data_stream2;
		static Int32 width;
		static Int32 height;
		static Int32 ppi;
		static double bitrate;
		static String comment_text;
		private UTF8Encoding utf8 = new UTF8Encoding();


		public Form1()
		{

            comment_text = String.Empty; //need to initialize comment_text in order to avoid crashing
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
           WSQ_library_native_methods = new WSQImageLibraryNativeMethods32();


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.buttonOpen = new System.Windows.Forms.Button();
            this.buttonSave = new System.Windows.Forms.Button();
            this.buttonRegister = new System.Windows.Forms.Button();
            this.OutputPicture = new System.Windows.Forms.PictureBox();
            this.buttonStreamToWSQ = new System.Windows.Forms.Button();
            this.buttonWSQtoStream = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.OutputPicture)).BeginInit();
            this.SuspendLayout();
            // 
            // buttonOpen
            // 
            this.buttonOpen.Location = new System.Drawing.Point(12, 360);
            this.buttonOpen.Name = "buttonOpen";
            this.buttonOpen.Size = new System.Drawing.Size(104, 32);
            this.buttonOpen.TabIndex = 0;
            this.buttonOpen.Text = "&Open";
            this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
            // 
            // buttonSave
            // 
            this.buttonSave.Enabled = false;
            this.buttonSave.Location = new System.Drawing.Point(130, 360);
            this.buttonSave.Name = "buttonSave";
            this.buttonSave.Size = new System.Drawing.Size(104, 32);
            this.buttonSave.TabIndex = 1;
            this.buttonSave.Text = "&Save";
            this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
            // 
            // buttonRegister
            // 
            this.buttonRegister.Location = new System.Drawing.Point(249, 312);
            this.buttonRegister.Name = "buttonRegister";
            this.buttonRegister.Size = new System.Drawing.Size(104, 32);
            this.buttonRegister.TabIndex = 4;
            this.buttonRegister.Text = "&Register";
            this.buttonRegister.Click += new System.EventHandler(this.buttonRegister_Click);
            // 
            // OutputPicture
            // 
            this.OutputPicture.Location = new System.Drawing.Point(0, 0);
            this.OutputPicture.Name = "OutputPicture";
            this.OutputPicture.Size = new System.Drawing.Size(353, 297);
            this.OutputPicture.TabIndex = 4;
            this.OutputPicture.TabStop = false;
            // 
            // buttonStreamToWSQ
            // 
            this.buttonStreamToWSQ.Enabled = false;
            this.buttonStreamToWSQ.Location = new System.Drawing.Point(130, 312);
            this.buttonStreamToWSQ.Name = "buttonStreamToWSQ";
            this.buttonStreamToWSQ.Size = new System.Drawing.Size(104, 32);
            this.buttonStreamToWSQ.TabIndex = 3;
            this.buttonStreamToWSQ.Text = "Stream -> WSQ";
            this.buttonStreamToWSQ.Click += new System.EventHandler(this.buttonStreamToWSQ_Click);
            // 
            // buttonWSQtoStream
            // 
            this.buttonWSQtoStream.Location = new System.Drawing.Point(12, 312);
            this.buttonWSQtoStream.Name = "buttonWSQtoStream";
            this.buttonWSQtoStream.Size = new System.Drawing.Size(104, 32);
            this.buttonWSQtoStream.TabIndex = 2;
            this.buttonWSQtoStream.Text = "WSQ -> stream";
            this.buttonWSQtoStream.Click += new System.EventHandler(this.buttonWSQtoStream_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(358, 405);
            this.Controls.Add(this.buttonStreamToWSQ);
            this.Controls.Add(this.buttonWSQtoStream);
            this.Controls.Add(this.buttonRegister);
            this.Controls.Add(this.buttonSave);
            this.Controls.Add(this.buttonOpen);
            this.Controls.Add(this.OutputPicture);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "WSQ Library Demo";
            ((System.ComponentModel.ISupportInitialize)(this.OutputPicture)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}



        // To call functions from WSQ_library.dll
		// you can use the methods from wrapper class WSQImageLibraryNativeMethods32
		// or you can use function prototypes provided below 

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern IntPtr _CreateBMPFromFile(byte[] filename);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SaveBMPToFile(IntPtr hBitmap, byte[] filename, Int32 filetype);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _RegisterWSQ();

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SetShowFilePropertiesDialog(Int32 file_properties_dialog);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _ShowFileConverter();

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern IntPtr _ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, byte[] filename);




		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog ofd = new OpenFileDialog();

			ofd.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;" +
"*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;" +
"*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp|" +
"FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|" +
"Windows bitmaps (*.bmp)|*.bmp|" +
"Macintosh TIFF images (*.tiff)|*.tiff|" +
"PC TIFF images (*.tif)|*.tif|" +
"JPG images (*.jpg)|*.jpg|" +
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" +
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" +
"JPE images (*.jpe)|*.jpe|" +
"JPEG images (*.jpeg)|*.jpeg|" +
"Portable network graphic images (*.png)|*.png" +
"Compuserve Graphic Interchange Format(*.gif)|*gif|" +
"Paintshop Pro images (*.psp)|*.psp|" +
"JFIF images (*.jfif)|*.jfif|" +
"Run length encoded Windows bitmaps (*.rle)|*.rle|" +
"Device independant Windows bitmaps (*.dib)|*.dib|" +
"Truevision images (*.win)|*.win|" +
"Truevision images (*.vst)|*.vst|" +
"Truevision images (*.vda)|*.vda|" +
"Truevision images (*.tga)|*.tga|" +
"Truevision images (*.icb)|*.icb|" +
"GFI fax images (*.fax)|*.fax" +
"Encapsulated Postscript images (*.eps)|*.eps|" +
"ZSoft Paintbrush images (*.pcx)|*.pcx|" +
"ZSoft Paintbrush images (*.pcc)|*.pcc|" +
"Word 5.x screen capture images (*.scr)|*.scr|" +
"Alias/Wavefront images (*.rpf)|*.rpf|" +
"Alias/Wavefront images (*.rla)|*.rla|" +
"SGI true color images (*.sgi)|*.sgi|" +
"SGI true color images with alpha (*.rgba)|*.rgba|" +
"SGI true color images (*.rgb)|*.rgb|" +
"SGI black/white images (*.bw)|*.bw|" +
"Photoshop images (*.psd)|*.psd|" +
"Photoshop images (*.pdd)|*.pdd|" +
"Portable pixel map images (*.ppm)|*.ppm|" +
"Portable gray map images (*.pgm)|*.pgm|" +
"Portable bitmap images (*.pbm)|*.pbm|" +
"Autodesk images (*.cel)|*.cel|" +
"Autodesk images (*.pic)|*.pic|" +
"Kodak Photo-CD images (*.pcd)|*.pcd|" +
"Dr. Halo images (*.cut)|*.cut|" +
"Amiga Bitmap Graphic (8 bits)|*.iff|" +
"Windows icons (*.ico)|*.ico|" +
"Windows metafiles (*.wmf)|*.wmf|" +
"Windows enhanced meta files (*.emf)|*.emf";

			ofd.FilterIndex = 1;
			if (ofd.ShowDialog() != DialogResult.OK)
			{
				return;
			}
			
			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //bp = _CreateBMPFromFile(utf8.GetBytes(ofd.FileName));
			bp = WSQ_library_native_methods.pCreateBMPFromFile(ofd.FileName);
			b = Image.FromHbitmap(bp);
			OutputPicture.Image = b;
            
			Int32 h = OutputPicture.Image.Height;
			Int32 w = OutputPicture.Image.Width;
			OutputPicture.SetBounds(0, 0, w, h);

			buttonSave.Enabled = true;

		}



		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog sfd = new SaveFileDialog();
			sfd.Filter = "WSQ Files (*.wsq)|*.wsq|" + // 1
"Windows BMP (*.bmp)|*.bmp|" + // 2
"TIFF Files (*.tif)|*.tif|" + //3
"PNG Files (*.png)|*.png|" + //4 
"JPEG Files (*.jpg)|*.jpg|" + // 5
"Targa Files (*.tga)|*.tga|" + // 6
"SGI Files (*.rgb)|*.rgb|" + // 7
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" + // 8
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" + // 9
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" + // 10
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" + // 11
"PPM - Portable Pixmap Format (*.ppm)|*.ppm"; // 12

			sfd.FilterIndex = 1;
			if (sfd.ShowDialog() != DialogResult.OK)
			{
				return;
			}

			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SetShowFilePropertiesDialog(1);
			WSQ_library_native_methods.pSetShowFilePropertiesDialog(1);

			Bitmap b;
			IntPtr bp;

			b = new Bitmap(OutputPicture.Image);
			bp = b.GetHbitmap();

			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
			//_SaveBMPToFile(bp, utf8.GetBytes(sfd.FileName), sfd.FilterIndex);
			WSQ_library_native_methods.pSaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);
		}

		private void buttonRegister_Click(object sender, System.EventArgs e)
		{
			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
			//_RegisterWSQ();
			WSQ_library_native_methods.pRegisterWSQ();
		}

		private void buttonWSQtoStream_Click(object sender, System.EventArgs e)
		{
		
			OpenFileDialog ofd = new OpenFileDialog();

			ofd.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

			ofd.FilterIndex = 1;
			if (ofd.ShowDialog() != DialogResult.OK)
			{
				return;
			}

			FileInfo fInfo = new FileInfo (ofd.FileName);
			long input_stream_length = fInfo.Length;
			FileStream fStream = new FileStream(ofd.FileName, FileMode.Open, FileAccess.Read);
			BinaryReader br = new BinaryReader(fStream);

			input_data_stream = br.ReadBytes((int)input_stream_length);

			WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, (int)input_stream_length,
				out output_data_stream, out width, out height, out ppi, out comment_text);

            //Converts WSQ compressed byte array into HBITMAP for showing on screen
			bp = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, (int)input_stream_length);
			b = Image.FromHbitmap(bp);
			OutputPicture.Image = b;
            
			Int32 h = OutputPicture.Image.Height;
			Int32 w = OutputPicture.Image.Width;
			OutputPicture.SetBounds(0, 0, w, h);

			int output_data_stream_length = height * width;

			// Saves WSQ compressed byte array to an image file.
			//WSQ_library_native_methods.pSaveWSQByteArrayToImageFile(input_data_stream, (int)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


			MessageBox.Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

			br.Close();
			fStream.Close();



			buttonStreamToWSQ.Enabled = true;
		
		}

		private void buttonStreamToWSQ_Click(object sender, System.EventArgs e)
		{

			SaveFileDialog sfd = new SaveFileDialog();
			sfd.Filter = "WSQ Files (*.wsq)|*.wsq";
			sfd.FilterIndex = 1;
			if (sfd.ShowDialog() != DialogResult.OK)
			{
				return;
			}


			bitrate = 0.75;
			ppi = 500;
			//comment_text = "";
			comment_text = "Cognaxon";


			input_data_stream2 = new byte[width*height];
			int row, row2, pixel_number, pixel_number2;

			// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
			for (int y = 0; y < height; y++)
			{
				row = width * y;
				row2 = width * (height - y - 1);
				for (int x = 0;  x < width; x++)
				{
					pixel_number = row + x;
					pixel_number2 = row2 + (width - x - 1);

					input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
				}
			}


			int compressedLength;
			WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, width, height, 
				bitrate, ppi, comment_text, out output_data_stream2, out compressedLength);


			FileStream fStream = new FileStream(sfd.FileName, FileMode.Create);
			BinaryWriter bw = new BinaryWriter(fStream);

			bw.Write(output_data_stream2);
			bw.Close();
			fStream.Close();
			MessageBox.Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");


		}
	}
}
